## pocl 0.13

=== CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

project(pocl)
set(MAJOR_VERSION 0)
set(MINOR_VERSION 13)
set(VERSION_SUFFIX "")
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}${VERSION_SUFFIX})
set(POCL_VERSION ${VERSION_STRING})

##################################################################################

if(CMAKE_SYSTEM_PROCESSOR MATCHES "ppc")
  set(POWERPC 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "mips")
  set(MIPS 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armv7")
  set(ARMV7 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armv6")
  set(ARMV6 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(i386|AMD64|x86_64)")
  if(POCL_DEVICE_ADDRESS_BITS MATCHES "32")
    set(I386 1)
  else()
    set(X86_64 1)
  endif()
endif()

######################################################################################

macro(set_expr VAR)
  if(${ARGN})
    set(${VAR} 1)
  else()
    set(${VAR} 0)
  endif()
endmacro()

function(rename_if_different SRC DST)
  if(EXISTS "${DST}")
    file(MD5 "${SRC}" OLD_MD5)
    file(MD5 "${DST}" NEW_MD5)
    if(NOT OLD_MD5 STREQUAL NEW_MD5)
      file(RENAME "${SRC}" "${DST}")
    endif()
  else()
    file(RENAME "${SRC}" "${DST}")
  endif()
endfunction()

######################################################################################

# Recent versions of CMake can make use of Ninja's console pool to avoid
# buffering the output of particular commands.
if(CMAKE_VERSION VERSION_LESS 3.2.0)
  set(COMMAND_USES_TERMINAL)
else()
  set(COMMAND_USES_TERMINAL USES_TERMINAL)
endif()

if(UNIX)
  include(GNUInstallDirs)
else()
  if (WIN32)
    set(${CMAKE_INSTALL_LIBDIR} "lib")
    set(${CMAKE_INSTALL_DATADIR} "share")
    set(${CMAKE_INSTALL_INCLUDEDIR} "include")
    set(${CMAKE_INSTALL_BINDIR} "bin")
    message(STATUS "Setting installation destination on Windows to: ${CMAKE_INSTALL_PREFIX}")
  else()
    message(FATAL_ERROR "System not UNIX nor WIN32 - not implemented yet")
  endif()
endif()

# for libpocl.so
set(POCL_INSTALL_PUBLIC_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" CACHE PATH "POCL public libdir")

# for llvmopencl.so
set(POCL_INSTALL_PRIVATE_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pocl" CACHE PATH "POCL private libdir")

# for pocl.icd
if(UNIX AND NOT CMAKE_CROSSCOMPILING)
  set(POCL_INSTALL_ICD_VENDORDIR "/etc/OpenCL/vendors" CACHE PATH "POCL ICD file destination")
else()
  set(POCL_INSTALL_ICD_VENDORDIR "${CMAKE_INSTALL_PREFIX}/etc/OpenCL/vendors" CACHE PATH "POCL ICD file destination")
endif()

# for kernel-<target>.bc
set(POCL_INSTALL_PRIVATE_DATADIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/pocl" CACHE PATH "POCL private datadir")

# for poclu.h
set(POCL_INSTALL_PUBLIC_HEADER_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}" CACHE PATH "POCL public header dir")

# for _kernel.h et al
set(POCL_INSTALL_PRIVATE_HEADER_DIR "${POCL_INSTALL_PRIVATE_DATADIR}/include" CACHE PATH "POCL private header dir")

# for pocl-standalone et al
set(POCL_INSTALL_PUBLIC_BINDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" CACHE PATH "POCL public bindir")

# for PoclConfig.cmake & stuff
set(POCL_INSTALL_CMAKE_CONFIG_DIR "${POCL_INSTALL_PRIVATE_LIBDIR}" CACHE PATH   "Installation directory for CMake files")

# TODO maybe use output of pkg-config --variable=pc_path pkg-config ?
set(POCL_INSTALL_PKGCONFIG_DIR "${POCL_INSTALL_PUBLIC_LIBDIR}/pkgconfig" CACHE PATH "Destination for pocl.pc")

if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(POCL_INSTALL_OPENCL_HEADER_DIR "${POCL_INSTALL_PUBLIC_HEADER_DIR}/OpenCL" CACHE PATH "POCL header dir for OpenCL headers")
else()
  set(POCL_INSTALL_OPENCL_HEADER_DIR "${POCL_INSTALL_PUBLIC_HEADER_DIR}/CL" CACHE PATH "POCL header dir for OpenCL headers")
endif()

option(BUILD_SHARED_LIBS "ON=Build shared libs, OFF=static libs" ON)

option(
  POCL_DEBUG_MESSAGES
  "Enable debug messages from pocl (useful for OpenCL developers), must be enabled at runtime, with env var POCL_DEBUG"
  ON)

# required b/c SHARED libs defaults to ON while OBJECT defaults to OFF
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

######################################################################################

# AMD HSA
option(ENABLE_HSA "Enable the HSA device driver for AMD GCN devices" OFF)

######################################################################################

enable_testing()

######################################################################################

if(UNIX)
  find_package(PkgConfig MODULE REQUIRED)
endif()

######################################################################################

set(ANDROID_COMPILER 0)
if(CMAKE_C_COMPILER MATCHES "android")
  set(ANDROID_COMPILER 1)
  add_definitions(-DPOCL_ANDROID)
  add_definitions(-DPOCL_ANDROID_PREFIX="/data/data/org.pocl.libs/files")
endif()

######################################################################################

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
find_package( Hwloc )

if(NOT Hwloc_FOUND)
  message(FATAL_ERROR "hwloc package is required!")
endif()

if("${Hwloc_VERSION}" VERSION_LESS "1.0")
  message(FATAL_ERROR "Hwloc version must be >= 1.0 !")
endif()

message(STATUS "Hwloc_VERSION ${Hwloc_VERSION}")
message(STATUS "Hwloc_LDFLAGS ${Hwloc_LDFLAGS}")
message(STATUS "Hwloc_CFLAGS ${Hwloc_CFLAGS}")

######################################################################################
#
# Find executables to few tools required during build 
#

find_program(PATCH_EXEC
  NAMES patch${CMAKE_EXECUTABLE_SUFFIX}
  HINTS ENV PATH
)

find_program(XARGS_EXEC
  NAMES xargs${CMAKE_EXECUTABLE_SUFFIX}
  HINTS ENV PATH
)

find_program(CAT_EXEC
  NAMES cat${CMAKE_EXECUTABLE_SUFFIX}
  HINTS ENV PATH
)

if(NOT PATCH_EXEC)
  message(FATAL_ERROR "Could not find patch command.")
endif()

######################################################################################

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(LLVM RESULT_VARIABLE RES)
if(NOT RES)
  message(FATAL_ERROR "Could not load LLVM.cmake")
endif()

if("${LLVM_VERSION}" VERSION_LESS "3.6")
  message(FATAL_ERROR "POCL requires LLVM version >= 3.6 !")
endif()

######################################################################################

# if variable FEATURE_X isnt defined, sets it to DEFAULT_FEATURE_X;
# also, if DEFAULT_FEATURE_X is 0, prevents FEATURE_X being 1
# since it takes DEFAULT_FEATURE_X=0 to mean "FEATURE_X is unavailable"
macro(setup_cached_var VARNAME DESCRIPTION DOCS_FEATURE_IS_UNAVAILABLE DOCS_REQUESTED_DISABLING_FEATURE)

  if(DEFINED ${VARNAME})
    set(_CACHED "(cached)")
  else()
    set(_CACHED "")
    set(${VARNAME} ${DEFAULT_${VARNAME}})
  endif()

  if(${VARNAME} AND (NOT ${DEFAULT_${VARNAME}}))
    message(WARNING "${DOCS_FEATURE_IS_UNAVAILABLE}")
    set(${VARNAME} 0)
    set(_CACHED "(override)")
  endif()
  if((NOT ${VARNAME}) AND ${DEFAULT_${VARNAME}} )
    message(STATUS "${DOCS_REQUESTED_DISABLING_FEATURE}")
  endif()
  if(${VARNAME})
    message(STATUS "${DESCRIPTION} ${_CACHED}: 1")
  else()
    message(STATUS "${DESCRIPTION} ${_CACHED}: 0")
  endif()
endmacro()


######################################################################################

if(NOT DEFINED DEFAULT_ENABLE_DOCS)
  include(Sphinx RESULT_VARIABLE RES)
  if(SPHINX_EXECUTABLE)
    set(DEFAULT_ENABLE_DOCS 1 CACHE INTERNAL "Enable building of documentation")
  else()
    set(DEFAULT_ENABLE_DOCS 0 CACHE INTERNAL "Enable building of documentation")
  endif()
endif()


setup_cached_var(ENABLE_DOCS "Documentation building"
  "Requested enabling documentation, but could not find Sphinx ! -> disabling docs.."
  "Sphinx found, but requested disabling docs")

######################################################################################

if(UNIX)
  include(CheckCSourceCompiles)
  CHECK_C_SOURCE_COMPILES("
#include <time.h>
int main() {
  struct timespec pocl_debug_timespec;
  clock_gettime(CLOCK_REALTIME, &pocl_debug_timespec);
  return 0;
}
  " HAVE_CLOCK_GETTIME)
else()
  set(HAVE_CLOCK_GETTIME 0)
endif()

include(CheckFunctionExists)
check_function_exists(fork HAVE_FORK)
check_function_exists(vfork HAVE_VFORK)

######################################################################################

if(NOT DEFINED DEFAULT_USE_VECMATHLIB)
  if(CLANGXX_WORKS AND EXISTS "${CMAKE_SOURCE_DIR}/lib/kernel/vecmathlib/vecmathlib.h")
    set(DEFAULT_USE_VECMATHLIB 1 CACHE INTERNAL "vecmathlib availability")
  else()
    set(DEFAULT_USE_VECMATHLIB 0 CACHE INTERNAL "vecmathlib availability")
  endif()
endif()

setup_cached_var(USE_VECMATHLIB "Vecmathlib use"
  "Requested enabling vecmathlib use, but either clang++ doesnt work or vecmathlib sources are missing.. -> disabling vecmathlib use"
  "Vecmathlib is usable, but requested disabling it")

# vecmathlib does not compile with fp16 currently
if(USE_VECMATHLIB AND (NOT CL_DISABLE_HALF))
  message(STATUS "Half available, but disabling half support since vecmathlib is enabled.")
  set(CL_DISABLE_HALF 1)
  set(CL_DISABLE_HALF 1 CACHE BOOL "Disable cl_khr_fp16 because fp16 is not supported")
endif()

######################################################################################

if(UNIX)
  if(APPLE)
    # MacOS ld outputs useless warnings like
    # ld: warning: -macosx_version_min not specificed, assuming 10.7
    # suppress them with -w.
    set(DEFAULT_HOST_LD_FLAGS "-Wl,-dylib -lm")
  elseif(ANDROID_COMPILER)
    set(DEFAULT_HOST_LD_FLAGS "-L/system/lib/ -shared -ldl -lc -lm /system/lib/crtbegin_so.o /system/lib/crtend_so.o")
  else()
    set(DEFAULT_HOST_LD_FLAGS "-shared -lm")
  endif()
  set(LIBMATH "-lm")
elseif(WIN32)
  set(LIBMATH)
endif()

######################################################################################

option(USE_VECMATHLIB_BUILTINS_ONLY "Use only __builtin_* functions in the kernel library." OFF)

set(DEFAULT_KERNEL_CL_FLAGS "-Xclang -cl-std=CL2.0 -D__OPENCL_C_VERSION__=200")
if(USE_VECMATHLIB)
  set(DEFAULT_KERNEL_CLANGXX_FLAGS "-DVML_NO_IOSTREAM ${CLANGXX_STDLIB}")
  if(USE_VECMATHLIB_BUILTINS_ONLY)
    set(DEFAULT_KERNEL_CL_FLAGS "${DEFAULT_KERNEL_CL_FLAGS} -DPOCL_VECMATHLIB_BUILTIN")
    set(DEFAULT_KERNEL_CLANGXX_FLAGS "${DEFAULT_KERNEL_CLANGXX_FLAGS} -DPOCL_VECMATHLIB_BUILTIN")
  endif()
endif()

set(EXTRA_KERNEL_CL_FLAGS "" CACHE STRING "Extra arguments to kernel CL compiler (defaults to empty)")
set(EXTRA_KERNEL_CXX_FLAGS "" CACHE STRING "Extra arguments to kernel CXX compiler (defaults to empty)")

set(KERNEL_CLANGXX_FLAGS "${DEFAULT_KERNEL_CLANGXX_FLAGS} ${EXTRA_KERNEL_CXX_FLAGS}")
set(KERNEL_CL_FLAGS "${DEFAULT_KERNEL_CL_FLAGS} ${EXTRA_KERNEL_CL_FLAGS}")

message(STATUS "Clang++ flags for compiling kernel library: ${KERNEL_CLANGXX_FLAGS}")

=== examples/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

add_subdirectory("example1")
add_subdirectory("example1-spir32")
add_subdirectory("example1-spir64")
add_subdirectory("example2")
add_subdirectory("example2a")
add_subdirectory("standalone")
add_subdirectory("scalarwave")
add_subdirectory("trig")
add_subdirectory("EinsteinToolkit")

# TODO:   opencl-book-samples  PyOpenCL
set(ALL_TESTSUITES
    AMD AMDSDK2.9 AMDSDK3.0
    ASL arrayfire clBLAS clFFT
    CloverLeaf Halide IntelSVM
    opencl-book-samples OpenCV
    Parboil piglit PyOpenCL
    Rodinia VexCL ViennaCL)

if("${ENABLE_TESTSUITES}" STREQUAL "all")
  set(ENABLE_TESTSUITES ${ALL_TESTSUITES})
endif()

message(STATUS "Trying to enable testsuites: ${ENABLE_TESTSUITES}")

include(ExternalProject)

set(ACTUALLY_ENABLED_TESTSUITES "")

# invoke this to build all examples
add_custom_target(prepare_examples)

if(ENABLE_TESTSUITES)

  if(NOT DEFINED TESTSUITE_BASEDIR)
    # TODO maybe current src dir ?
    set(TESTSUITE_BASEDIR "${CMAKE_CURRENT_BINARY_DIR}")
  endif()
  if(NOT IS_DIRECTORY "${TESTSUITE_BASEDIR}")
    message(FATAL_ERROR "TESTSUITE_BASEDIR (${TESTSUITE_BASEDIR}) is not a directory.")
  endif()

  if(NOT DEFINED TESTSUITE_SOURCE_BASEDIR)
    set(TESTSUITE_SOURCE_BASEDIR "${CMAKE_CURRENT_SOURCE_DIR}")
  endif()
  if(NOT IS_DIRECTORY "${TESTSUITE_SOURCE_BASEDIR}")
    message(FATAL_ERROR "TESTSUITE_SOURCE_BASEDIR (${TESTSUITE_SOURCE_BASEDIR}) is not a directory.")
  endif()

  message(STATUS "Testsuite base dirs: ")
  message(STATUS "    binary: ${TESTSUITE_BASEDIR}")
  message(STATUS "    source: ${TESTSUITE_SOURCE_BASEDIR}")

  foreach(TESTSUITE IN LISTS ENABLE_TESTSUITES)
    if(ALL_TESTSUITES MATCHES ${TESTSUITE})
      if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${TESTSUITE}")
        add_subdirectory("${TESTSUITE}")
      else()
        message(FATAL_ERROR "Cannot find source dir for testsuite: ${TESTSUITE}")
      endif()
    else()
      message(WARNING "Unknown testsuite ${TESTSUITE} requested")
    endif()
  endforeach()
endif()

set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)
set(ALL_TESTSUITES ${ALL_TESTSUITES} PARENT_SCOPE)

=== include/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

add_subdirectory("CL")

set(PRIVATE_HEADERS  _kernel.h _kernel_c.h _kernel_constants.h pocl_types.h pocl_device.h pocl.h)

install(FILES ${PRIVATE_HEADERS}
        DESTINATION ${POCL_INSTALL_PRIVATE_HEADER_DIR})

install(FILES "poclu.h"
        DESTINATION ${POCL_INSTALL_PUBLIC_HEADER_DIR})

=== lib/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

separate_arguments(HOST_CLANG_FLAGS)
separate_arguments(HOST_LLC_FLAGS)

add_subdirectory("kernel")

add_subdirectory("llvmopencl")

add_subdirectory("CL")

#############################################################

# must be after tce b/c of LD_FLAGS_BIN
# and after adding lib/CL subdir b/c of libpocl location,
# but before poclu & examples & tests (they need these variables)

set(OPENCL_CFLAGS "${PTHREAD_CFLAGS}")

if(TESTS_USE_ICD)

  if(OPENCL_FOUND)
    set(OPENCL_LIBS ${OPENCL_LIBRARIES})
  else()
    message(WARNING "Tests-use-ICD requested, but cannot find an OpenCL library; adding -lOpenCL to LDFLAGS")
    set(OPENCL_LIBS "OpenCL")
  endif()

  set(OPENCL_LIBS "${PTHREAD_LDFLAGS};${OPENCL_LIBS}")

  set(OPENCL_EXTLIBS ${OPENCL_LIBS})
  set(OPENCL_CMAKE_OPTIONS "")

else()

  # used by examples / tests

  #OPENCL_LIBS='$(abs_top_builddir)/lib/CL/libpocl.la $(PTHREAD_LIBS) $(LD_FLAGS_BIN)'
  set(OPENCL_LIBS ${LD_FLAGS_BIN} "OpenCL")

  # TODO used by Rodinia makefile.am ?
  #OPENCL_EXTLIBS='-L$(abs_top_builddir)/lib/CL/.libs -lpocl -Xlinker -rpath=${abs_top_builddir}/lib/CL/.libs $(PTHREAD_LIBS) $(LD_FLAGS_BIN)'
  set(OPENCL_EXTLIBS "TODO_FIX_THIS")

  #~ OPENCL_CMAKE=' \
  #~ -D OPENCL_LIBRARIES:FILEPATH=${abs_top_builddir}/lib/CL/.libs/libpocl.so \
  #~ -D OPENCL_LIBRARY:FILEPATH=${abs_top_builddir}/lib/CL/.libs/libpocl.so \
  #~ -D CMAKE_EXE_LINKER_FLAGS:STRING='${CMAKE_THREAD_LIBS_INIT}' \
  #~ -D OPENCL_INCLUDE_DIRS:PATH=${abs_top_srcdir}/include \
  #~ -D OPENCL_INCLUDE_DIR:PATH=${abs_top_srcdir}/include
  #~ '
  set(OPENCL_CMAKE_OPTIONS "-D OPENCL_LIBRARIES:FILEPATH='$<TARGET_FILE:pocl>'
                            -D OPENCL_LIBRARY:FILEPATH='$<TARGET_FILE:pocl>'
                            -D CMAKE_EXE_LINKER_FLAGS:STRING='${CMAKE_THREAD_LIBS_INIT}'
                            -D OPENCL_INCLUDE_DIRS:PATH='${CMAKE_SOURCE_DIR}/include'
                            -D OPENCL_INCLUDE_DIR:PATH='${CMAKE_SOURCE_DIR}/include' ")

endif()

set(OPENCL_LIBS "${OPENCL_LIBS}" PARENT_SCOPE)
set(OPENCL_EXTLIBS "${OPENCL_EXTLIBS}" PARENT_SCOPE)
set(OPENCL_CMAKE_OPTIONS "${OPENCL_CMAKE_OPTIONS}" PARENT_SCOPE)
set(OPENCL_CFLAGS "${OPENCL_CFLAGS}" PARENT_SCOPE)

add_subdirectory("poclu")

=== scripts/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

if(UNIX)

  if((X86_64 OR I386) AND KERNELLIB_HOST_DISTRO_VARIANTS)
    set(KERNLIB_VARIANT "sse2")
  else()
    set(KERNLIB_VARIANT "${LLC_HOST_CPU}")
  endif()

  # build-dir script
  set(LLVMOPENCL_LOCATION "$<TARGET_FILE:llvmopencl>")
  set(KERNEL_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/include")
  set(ADD_INCLUDE "-I${CMAKE_BINARY_DIR}")
  set(FULL_TARGET_DIR "${CMAKE_BINARY_DIR}/lib/kernel/\${target_dir}")
  configure_file("${CMAKE_SOURCE_DIR}/scripts/pocl-standalone.in.cmake" "${CMAKE_BINARY_DIR}/scripts/pocl-standalone.in" ESCAPE_QUOTES @ONLY)
  file(GENERATE OUTPUT "${CMAKE_BINARY_DIR}/scripts/pocl-standalone" INPUT "${CMAKE_BINARY_DIR}/scripts/pocl-standalone.in")

  # install script
  set(LLVMOPENCL_LOCATION "${POCL_INSTALL_PRIVATE_LIBDIR}/$<TARGET_FILE_NAME:llvmopencl>")
  set(KERNEL_INCLUDE_DIR "${POCL_INSTALL_PRIVATE_HEADER_DIR}")
  set(ADD_INCLUDE "")
  set(FULL_TARGET_DIR "${POCL_INSTALL_PRIVATE_DATADIR}")
  configure_file("${CMAKE_SOURCE_DIR}/scripts/pocl-standalone.in.cmake" "${CMAKE_BINARY_DIR}/scripts/pocl-standalone.install.in" ESCAPE_QUOTES @ONLY)
  file(GENERATE OUTPUT "${CMAKE_BINARY_DIR}/scripts/pocl-standalone.install" INPUT "${CMAKE_BINARY_DIR}/scripts/pocl-standalone.install.in")

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pocl-standalone.install" RENAME "pocl-standalone"
        DESTINATION ${POCL_INSTALL_PUBLIC_BINDIR})

endif()

=== examples/AMD/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================


if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" AND X86_64)

  set(TS_NAME AMD)
  set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
  set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
  set(AMD_APP_SDK_TGZ "${TS_SRCDIR}/AMD-APP-SDK-v2.8-RC-lnx64.tgz")

  if(EXISTS "${AMD_APP_SDK_TGZ}")

    message(STATUS "Enabling testsuite ${TS_NAME}")
    list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
    set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

    ExternalProject_Add(
      ${TS_NAME}
      PREFIX "${TS_BASEDIR}"
      DOWNLOAD_COMMAND "/bin/true"
      PATCH_COMMAND tar -xzf "${AMD_APP_SDK_TGZ}" && pwd && patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/AMDSDK.patch
      CONFIGURE_COMMAND "/bin/true"
      BUILD_IN_SOURCE 1
      BUILD_COMMAND "/bin/true"
      INSTALL_COMMAND "/bin/true"
    )

    set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
    add_dependencies(prepare_examples ${TS_NAME})

    set(AMD_SAMPLES
    AESEncryptDecrypt
    AtomicCounters
    BinarySearch
    BinomialOption
    BinomialOptionMultiGPU
    BitonicSort
    BlackScholes
    BlackScholesDP
    BoxFilter
    BufferBandwidth
    DCT
    DeviceFission
    DeviceFission11Ext
    DwtHaar1D
    FastWalshTransform
    FloydWarshall
    HelloWorld
    Histogram
    ImageBandwidth
    ImageOverlap
    KernelLaunch
    LUDecomposition
    MatrixMulImage
    MatrixMultiplication
    MatrixTranspose
    MemoryModel
    MonteCarloAsian
    MonteCarloAsianMultiGPU
    PrefixSum
    QuasiRandomSequence
    RadixSort
    RecursiveGaussian
    Reduction
    ScanLargeArrays
    SimpleConvolution
    SimpleImage
    SimpleMultiDevice
    SobelFilter
    Template
    TemplateC
    TransferOverlap
    URNG)

    # disabled tests:  Mandelbrot NBody
    #   SimpleGL BoxFilterGL FluidSimulation2D GaussianNoiseGL
    #   MonteCarloAsianDP AdvancedMultiGPU BasicDebug

    foreach(SAMPLE IN LISTS AMD_SAMPLES)
      add_test(NAME "AMD_28_${SAMPLE}"
        COMMAND "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.8-RC-lnx64/samples/opencl/bin/x86_64/${SAMPLE}"
        WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.8-RC-lnx64/samples/opencl/bin/x86_64")
      set_tests_properties("AMD_28_${SAMPLE}" PROPERTIES LABELS "amdsdk_28")
    endforeach()

  else()
    message(WARNING "Disabling testsuite ${TS_NAME} - tarball not found")
  endif()

else()
  message(warning "AMD APP SDK testsuite is only enabled for x86_64 Linux systems currently")
endif()

=== examples/AMDSDK2.9/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================


if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" AND X86_64)

  set(TS_NAME AMDSDK2.9)
  set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
  set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
  set(AMD_APP_SDK_TGZ "${TS_SRCDIR}/AMD-APP-SDK-v2.9-RC-lnx64.tgz")

  if(EXISTS "${AMD_APP_SDK_TGZ}")

    message(STATUS "Enabling testsuite ${TS_NAME}")
    list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
    set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

    ExternalProject_Add(
      ${TS_NAME}
      PREFIX "${TS_BASEDIR}"
      DOWNLOAD_COMMAND "/bin/true"
      PATCH_COMMAND tar -xzf "${AMD_APP_SDK_TGZ}" && pwd && patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/AMDSDK2_9.patch
      CONFIGURE_COMMAND "/bin/true"
      BUILD_IN_SOURCE 1
      BUILD_COMMAND "/bin/true"
      INSTALL_COMMAND "/bin/true"
    )

    set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
    add_dependencies(prepare_examples ${TS_NAME})

    set(AMD_SAMPLES
    BinarySearch
    BinomialOption
    BinomialOptionMultiGPU
    BitonicSort
    BlackScholes
    BlackScholesDP
    DCT
    DwtHaar1D
    DynamicOpenCLDetection
    FastWalshTransform
    FloydWarshall
    GlobalMemoryBandwidth
    HelloWorld
    Histogram
    HistogramAtomics
    ImageOverlap
    LUDecomposition
    MatrixMulImage
    MatrixMultiplication
    MatrixTranspose
    MemoryModel
    MonteCarloAsianMultiGPU
    PrefixSum
    QuasiRandomSequence
    RadixSort
    RecursiveGaussian
    Reduction
    ScanLargeArrays
    SimpleConvolution
    SimpleImage
    SimpleMultiDevice
    SobelFilter
    StringSearch
    Template
    TransferOverlap
    URNG
    URNGNoiseGL)

    # disabled c++ tests: DwtHaar1DCPPKernel EigenValue FFT IntroStaticCPPKernel MatrixMultiplicationCPPKernel MersenneTwister SoAversusAoS TransferOverlapCPP
    # disabled but fixable: CplusplusWrapper DeviceFission FluidSimulation2D GaussianNoise HDRToneMapping ImageBandwidth KernelLaunch MatrixMulDouble MonteCarloAsian MonteCarloAsianDP SobelFilterImage UnsharpMask
    # disabled tests: NBody AtomicCounters BasicDebug DeviceFission11Ext
    # disabled graphics tests: Mandelbrot  KmeansAutoclustering GaussianNoiseGL SimpleGL
    # very slow: LDSBandwidth ConstantBandwidth MemoryOptimizations

    foreach(SAMPLE IN LISTS AMD_SAMPLES)
      add_test(NAME "AMD_29_${SAMPLE}"
        COMMAND "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.9-RC-lnx64/samples/opencl/bin/x86_64/${SAMPLE}"
        WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-v2.9-RC-lnx64/samples/opencl/bin/x86_64")
      set_tests_properties("AMD_29_${SAMPLE}" PROPERTIES LABELS "amdsdk_29")
    endforeach()

  # TODO
  set_tests_properties(
    AMD_29_BitonicSort AMD_29_BinarySearch AMD_29_BinomialOption AMD_29_DCT
    AMD_29_BlackScholes AMD_29_FastWalshTransform AMD_29_FloydWarshall
    AMD_29_HelloWorld AMD_29_Histogram AMD_29_MatrixMultiplication
    AMD_29_MatrixTranspose AMD_29_PrefixSum AMD_29_QuasiRandomSequence
    AMD_29_ScanLargeArrays AMD_29_SimpleConvolution AMD_29_URNG
    PROPERTIES
      LABELS "hsa")


  else()
    message(WARNING "Disabling testsuite ${TS_NAME} - tarball not found")
  endif()

else()
  message(warning "AMD APP SDK testsuite is only enabled for x86_64 Linux systems currently")
endif()

=== examples/AMDSDK3.0/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================


if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" AND X86_64)

  set(TS_NAME AMDSDK3.0)
  set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
  set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
  set(AMD_APP_SDK_TGZ "${TS_SRCDIR}/AMD-APP-SDK-v3.0.130.135-GA-linux64.sh")

  if(EXISTS "${AMD_APP_SDK_TGZ}")

    message(STATUS "Enabling testsuite ${TS_NAME}")
    list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
    set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

    ExternalProject_Add(
      ${TS_NAME}
      PREFIX "${TS_BASEDIR}"
      DOWNLOAD_COMMAND "/bin/true"
      PATCH_COMMAND /bin/sh "${AMD_APP_SDK_TGZ}" --noexec --keep --target AMD-APP-SDK-3.0 &&
             patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/amdsdk3_0.patch
      CONFIGURE_COMMAND "/bin/true"
      BUILD_IN_SOURCE 1
      BUILD_COMMAND "/bin/true"
      INSTALL_COMMAND "/bin/true"
    )

    set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
    add_dependencies(prepare_examples ${TS_NAME})

    set(AMD_SAMPLES
    AdvancedConvolution
    BasicDebug
    BinomialOption
    BinomialOptionMultiGPU
    BitonicSort
    BlackScholes
    BlackScholesDP
    BoxFilter
    BufferImageInterop
    BuiltInScan
    CalcPie
    ConcurrentKernel
    DCT
    DeviceFission
    DeviceFission11Ext
    DwtHaar1D
    FastWalshTransform
    FloydWarshall
    GaussianNoise
    HDRToneMapping
    HelloWorld
    Histogram
    HistogramAtomics
    ImageBinarization
    ImageOverlap
    KernelLaunch
    LUDecomposition
    MatrixMulImage
    MatrixMultiplication
    MatrixTranspose
    MemoryModel
    MonteCarloAsian
    MonteCarloAsianMultiGPU
    NBody
    PrefixSum
    QuasiRandomSequence
    RadixSort
    RecursiveGaussian
    Reduction
    ScanLargeArrays
    SimpleConvolution
    SimpleImage
    SimpleMultiDevice
    SobelFilter
    StringSearch
    Template
    UnsharpMask
    URNG)

    # freeze (requires async queue): FineGrainSVM
    # disabled c++ tests: DwtHaar1DCPPKernel EigenValue
    #     IntroStaticCPPKernel FFT MatrixMultiplicationCPPKernel
    #     MersenneTwister SoAversusAoS TransferOverlapCPP
    # disabled but fixable: BuiltInScan CalcPie CplusplusWrapper
    #     DeviceFission FluidSimulation2D GaussianNoise HDRToneMapping
    #     HeatPDE ImageBandwidth KernelLaunch MatrixMulDouble
    #     MonteCarloAsianDP SobelFilterImage UnsharpMask DynamicOpenCLDetection
    #     FineGrainSVMCAS RecursiveGaussian_ProgramScope SobelFilterImage
    #     SVMAtomicsBinaryTreeInsert SVMBinaryTreeSearch
    # disabled tests: AsyncDataTransfer AtomicCounters BasicDebug
    #     DeviceFission11Ext RangeMinimumQuery SimpleDepthImage
    #     SimpleGenericAddressSpace
    # disabled graphics tests: Mandelbrot  KmeansAutoclustering
    #     GaussianNoiseGL SimpleGL BoxFilterGL URNGNoiseGL
    # very slow: BufferBandwidth LDSBandwidth ConstantBandwidth
    #     MemoryOptimizations TransferOverlap
    # disabled - requires dev queue: BinarySearchDeviceSideEnqueue
    #     DeviceEnqueueBFS ExtractPrimes GlobalMemoryBandwidth
    #     RegionGrowingSegmentation SimpleSPIR
    # disabled - requires pipe: PipeProducerConsumerKernels SimplePipe


    foreach(SAMPLE IN LISTS AMD_SAMPLES)
      add_test(NAME "AMD_30_${SAMPLE}"
        COMMAND "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-3.0/samples/opencl/bin/x86_64/${SAMPLE}"
        WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-3.0/samples/opencl/bin/x86_64")
      set_tests_properties("AMD_30_${SAMPLE}" PROPERTIES LABELS "amdsdk_30")
    endforeach()

    # AMD_30_HeatPDE
    # AMD_30_FineGrainSVMCAS
    set_tests_properties(
        AMD_30_BinomialOption AMD_30_CalcPie AMD_30_DCT AMD_30_BlackScholes
        AMD_30_FastWalshTransform AMD_30_FloydWarshall AMD_30_HelloWorld
        AMD_30_Histogram AMD_30_MatrixMultiplication AMD_30_MatrixTranspose
        AMD_30_PrefixSum AMD_30_QuasiRandomSequence AMD_30_ScanLargeArrays
        AMD_30_SimpleConvolution AMD_30_URNG
      PROPERTIES
        LABELS "hsa")

  else()
    message(WARNING "Disabling testsuite ${TS_NAME} - tarball not found")
  endif()

else()
  message(warning "AMD APP SDK testsuite is only enabled for x86_64 Linux systems currently")
endif()

=== examples/ASL/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "ASL")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
set(ASL_TGZ "${TS_SRCDIR}/v0.1.6.tar.gz")

# find required libs - boost & vtk
find_package(Boost 1.55)
find_package(VTK)
set(VTK_VER "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")

if ((NOT "${CMAKE_VERSION}" VERSION_LESS "3.0.2")
    AND VTK_FOUND AND (NOT VTK_VER VERSION_LESS "6.1")
    AND Boost_FOUND AND (NOT Boost_VERSION VERSION_LESS "1.55"))

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    # GIT_REPOSITORY "https://github.com/AvtechScientific/ASL"
    URL "https://github.com/AvtechScientific/ASL/archive/v0.1.6.tar.gz"
    CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      -DWITH_API_DOC:BOOL=OFF
      -DWITH_EXAMPLES:BOOL=ON
      -DWITH_MATIO:BOOL=OFF
      -DWITH_TESTS:BOOL=ON
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
      "-DCMAKE_C_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME ASL_testABDFormat
           COMMAND "${TS_BUILDDIR}/test/testABD/testABDFormat")
  add_test(NAME ASL_testVectorOfElements
           COMMAND "${TS_BUILDDIR}/test/testACL/testVectorOfElements")
  add_test(NAME ASL_testMatrixOfElements
           COMMAND "${TS_BUILDDIR}/test/testACL/testMatrixOfElements")
  add_test(NAME ASL_testKernel
           COMMAND "${TS_BUILDDIR}/test/testACL/testKernel")
  add_test(NAME ASL_testOperators
           COMMAND "${TS_BUILDDIR}/test/testACL/testOperators")
  add_test(NAME ASL_testKernelMerger
           COMMAND "${TS_BUILDDIR}/test/testACL/testKernelMerger")
  add_test(NAME ASL_testPrivateVar
           COMMAND "${TS_BUILDDIR}/test/testACL/testPrivateVar")
  add_test(NAME ASL_testASLData
           COMMAND "${TS_BUILDDIR}/test/testMath/testASLData")
  add_test(NAME ASL_testDistanceFunction
           COMMAND "${TS_BUILDDIR}/test/testMath/testDistanceFunction")
  add_test(NAME ASL_testReductionFunction
           COMMAND "${TS_BUILDDIR}/test/testMath/testReductionFunction")


  add_test(NAME ASL_example_bus_wind
           COMMAND "${TS_BUILDDIR}/examples/flow/bus_wind/asl-bus_wind")
  add_test(NAME ASL_example_compressor
           COMMAND "${TS_BUILDDIR}/examples/flow/compressor/asl-compressor")
  add_test(NAME ASL_example_flow
           COMMAND "${TS_BUILDDIR}/examples/flow/flow/asl-flow")
  add_test(NAME ASL_example_flow2
           COMMAND "${TS_BUILDDIR}/examples/flow/flow2/asl-flow2")
  add_test(NAME ASL_example_flow3
           COMMAND "${TS_BUILDDIR}/examples/flow/flow3/asl-flow3")
  add_test(NAME ASL_example_flowKDPGrowth
           COMMAND "${TS_BUILDDIR}/examples/flow/flowKDPGrowth/asl-flowKDPGrowth")
  add_test(NAME ASL_example_flowRotatingCylinders
           COMMAND "${TS_BUILDDIR}/examples/flow/flowRotatingCylinders/asl-flowRotatingCylinders")
  add_test(NAME ASL_example_locomotive
           COMMAND "${TS_BUILDDIR}/examples/flow/locomotive/asl-locomotive")
  add_test(NAME ASL_example_locomotive_laminar
           COMMAND "${TS_BUILDDIR}/examples/flow/locomotive_laminar/asl-locomotive_laminar")
  add_test(NAME ASL_example_locomotive_stability
           COMMAND "${TS_BUILDDIR}/examples/flow/locomotive_stability/asl-locomotive_stability")
  add_test(NAME ASL_example_multicomponent_flow
           COMMAND "${TS_BUILDDIR}/examples/flow/multicomponent_flow/asl-multicomponent_flow")
  add_test(NAME ASL_example_multiphase_flow
           COMMAND "${TS_BUILDDIR}/examples/flow/multiphase_flow/asl-multiphase_flow")
  add_test(NAME ASL_example_pitot_tube_ice
           COMMAND "${TS_BUILDDIR}/examples/flow/pitot_tube_ice/asl-pitot_tube_ice")
  add_test(NAME ASL_example_acousticWaves
           COMMAND "${TS_BUILDDIR}/examples/elastic/acousticWaves/asl-acousticWaves")
  add_test(NAME ASL_example_cubeGravity
           COMMAND "${TS_BUILDDIR}/examples/elastic/cubeGravity/asl-cubeGravity")
  add_test(NAME ASL_example_cubeIncompressibleGravity
           COMMAND "${TS_BUILDDIR}/examples/elastic/cubeIncompressibleGravity/asl-cubeIncompressibleGravity")
  add_test(NAME ASL_example_cubePoroelasticGravity
           COMMAND "${TS_BUILDDIR}/examples/elastic/cubePoroelasticGravity/asl-cubePoroelasticGravity")
  add_test(NAME ASL_example_poroelastic
           COMMAND "${TS_BUILDDIR}/examples/elastic/poroelastic/asl-poroelastic")
  add_test(NAME ASL_example_levelSetBasic
           COMMAND "${TS_BUILDDIR}/examples/levelSet/levelSetBasic/asl-levelSetBasic")
  add_test(NAME ASL_example_levelSetFacetedGrowth
           COMMAND "${TS_BUILDDIR}/examples/levelSet/levelSetFacetedGrowth/asl-levelSetFacetedGrowth")
  add_test(NAME ASL_example_levelSetNormalGrowth
           COMMAND "${TS_BUILDDIR}/examples/levelSet/levelSetNormalGrowth/asl-levelSetNormalGrowth")
  add_test(NAME ASL_example_jumpingBox
           COMMAND "${TS_BUILDDIR}/examples/jumpingObjects/jumpingBox/asl-jumpingBox")
  add_test(NAME ASL_example_surfaceFlux
           COMMAND "${TS_BUILDDIR}/examples/heatTransfer/surfaceFlux/asl-surfaceFlux")
  add_test(NAME ASL_example_testSMDiff
           COMMAND "${TS_BUILDDIR}/examples/massTransferSM/testSMDiff/asl-testSMDiff")
  add_test(NAME ASL_example_testSMDiff3C
           COMMAND "${TS_BUILDDIR}/examples/massTransferSM/testSMDiff3C/asl-testSMDiff3C")
  add_test(NAME ASL_example_testSMPhi
           COMMAND "${TS_BUILDDIR}/examples/massTransferSM/testSMPhi/asl-testSMPhi")
  add_test(NAME ASL_example_testSMPhiBV
           COMMAND "${TS_BUILDDIR}/examples/massTransferSM/testSMPhiBV/asl-testSMPhiBV")


  set_tests_properties(
    ASL_testABDFormat
    ASL_testVectorOfElements
    ASL_testMatrixOfElements
    ASL_testKernel
    ASL_testOperators
    ASL_testKernelMerger
    ASL_testPrivateVar
    ASL_testASLData
    ASL_testDistanceFunction
    ASL_testReductionFunction
    ASL_example_bus_wind
    ASL_example_compressor
    ASL_example_flow
    ASL_example_flow2
    ASL_example_flow3
    ASL_example_flowKDPGrowth
    ASL_example_flowRotatingCylinders
    ASL_example_locomotive
    ASL_example_locomotive_laminar
    ASL_example_locomotive_stability
    ASL_example_multicomponent_flow
    ASL_example_multiphase_flow
    ASL_example_pitot_tube_ice
    ASL_example_acousticWaves
    ASL_example_cubeGravity
    ASL_example_cubeIncompressibleGravity
    ASL_example_cubePoroelasticGravity
    ASL_example_poroelastic
    ASL_example_levelSetBasic
    ASL_example_levelSetFacetedGrowth
    ASL_example_levelSetNormalGrowth
    ASL_example_jumpingBox
    ASL_example_surfaceFlux
    ASL_example_testSMDiff
    ASL_example_testSMDiff3C
    ASL_example_testSMPhi
    ASL_example_testSMPhiBV

    PROPERTIES
      LABELS "ASL")

else()

  message(STATUS "Disabling testsuite ${TS_NAME}, required files not found" )

endif()

=== examples/CloverLeaf/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME CloverLeaf)
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

message(STATUS "Enabling testsuite ${TS_NAME}")
list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

if(UNIX)
  pkg_check_modules(OPENMPI ompi)
  if (OPENMPI_FOUND)
    set(EXTRA_LIB_HINTS "HINTS" "${OPENMPI_LIBRARY_DIRS}")
  endif()
endif()

#You need to have "openmpi" and "gfortran" packages installed to build it.
find_program(MPI_F90 mpif90)
find_program(MPI_CC  mpicc)
find_program(MPI_CXX  mpiCC)
find_library(MPI_LIB mpi_cxx ${EXTRA_LIB_HINTS})

if (MPI_F90 AND MPI_CC AND MPI_CXX AND MPI_LIB)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    #DOWNLOAD_COMMAND "/bin/true"
    GIT_REPOSITORY "https://github.com/UK-MAC/CloverLeaf_OpenCL.git"
    GIT_TAG "Bristol"
    CONFIGURE_COMMAND "/bin/true"
    BUILD_IN_SOURCE 1
    BUILD_COMMAND
      make COMPILER=GNU
      "C_OPTIONS=-g -I${CMAKE_SOURCE_DIR}/include -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
      "MPI_COMPILER=${MPI_F90}"
      "C_MPI_COMPILER=${MPI_CC}"
      "CXX_MPI_COMPILER=${MPI_CXX}"
      "MPICXX_LIB=${MPI_LIB}"
    INSTALL_COMMAND "/bin/true"
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME CloverLeaf
           COMMAND "${TS_BUILDDIR}/clover_leaf")

  set_tests_properties(CloverLeaf
    PROPERTIES
      LABELS "CloverLeaf")

else()

  message(STATUS "Disabling testsuite ${TS_NAME}, required files not found" )

endif()

=== examples/EinsteinToolkit/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

#AM_CPPFLAGS = -I$(top_srcdir)/fix-include -I$(top_srcdir)/include -DSRCDIR='"$(abs_srcdir)"'
add_definitions("-DSRCDIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

# EinsteinToolkit_CFLAGS = @OPENCL_CFLAGS@
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 ${OPENCL_CFLAGS}")
add_compile_options(${OPENCL_CFLAGS} -std=c99)

if (MSVC)
  set_source_files_properties( EinsteinToolkit.c PROPERTIES LANGUAGE CXX )
endif(MSVC)
add_executable("EinsteinToolkit" EinsteinToolkit.c ML_BSSN_CL_RHS1.cl ML_BSSN_CL_RHS2.cl)

# EinsteinToolkit_LDADD = @OPENCL_LIBS@ ../../lib/poclu/libpoclu.la
target_link_libraries("EinsteinToolkit" ${POCLU_LINK_OPTIONS})

add_test(NAME "EinsteinToolkit" COMMAND "EinsteinToolkit")

set_tests_properties( "EinsteinToolkit"
  PROPERTIES
    LABELS "internal;Einstein"
    DEPENDS "pocl_version_check")

=== examples/Halide/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME Halide)
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

message(STATUS "Enabling testsuite ${TS_NAME}")
list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

# Halide disabled for now, need to find out which tests actually use OpenCL
if(0)

ExternalProject_Add(
  ${TS_NAME}
  PREFIX "${TS_BASEDIR}"
  #DOWNLOAD_COMMAND "/bin/true"
  GIT_REPOSITORY "https://github.com/Halide/Halide.git"
  #PATCH_COMMAND /bin/sh "${AMD_APP_SDK_TGZ}" --noexec --keep --target AMD-APP-SDK-3.0 &&
  #     patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/amdsdk3_0.patch
  CMAKE_ARGS
    -DCMAKE_BUILD_TYPE=RelWithDebInfo
    -DTARGET_ARM=OFF
    -DTARGET_AARCH64=OFF
    -DTARGET_MIPS=OFF
    -DTARGET_METAL=OFF
    -DTARGET_OPENCL=ON
    -DTARGET_OPENGL=OFF
    -DTARGET_OPENGLCOMPUTE=OFF
    -DTARGET_PTX=OFF
    -DTARGET_X86=ON
  CMAKE_CACHE_ARGS
    "-DLLVM_BIN:STRING=${LLVM_BINDIR}"
    "-DLLVM_LIB:STRING=${LLVM_LIBDIR}"
    "-DLLVM_INCLUDE:STRING=${LLVM_INCLUDEDIR}"
    "-DLLVM_VERSION:STRING=${LLVM_MAJOR}${LLVM_MINOR}"
  INSTALL_COMMAND "/bin/true"
)

set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
add_dependencies(prepare_examples ${TS_NAME})

# TODO Probably not tests
# acquire_release.generator argvcall.generator cleanup_on_error.generator
# embed_image.generator example.generator extended_buffer_t.generator
# error_codes.generator gpu_object_lifetime.generator gpu_only.generator
# mandelbrot.generator matlab.generator metadata_tester.generator
# nested_externs.generator paramtest.generator pyramid.generator
# runtime.generator tiled_blur.generator tiled_blur_blur.generator
# user_context.generator user_context_insanity.generator

add_test(NAME halide_bilateral_grid
         COMMAND "${TS_BUILDDIR}/bin/bilateral_grid")
add_test(NAME halide_bitcode2cpp
         COMMAND "${TS_BUILDDIR}/bin/bitcode2cpp")
add_test(NAME halide_blur_test
         COMMAND "${TS_BUILDDIR}/bin/blur_test")
add_test(NAME halide_build_halide_h
         COMMAND "${TS_BUILDDIR}/bin/build_halide_h")
add_test(NAME halide_camera_pipe
         COMMAND "${TS_BUILDDIR}/bin/camera_pipe")
add_test(NAME halide_correctness_argmax
         COMMAND "${TS_BUILDDIR}/bin/correctness_argmax")
add_test(NAME halide_correctness_assertion_failure_in_parallel_for
         COMMAND "${TS_BUILDDIR}/bin/correctness_assertion_failure_in_parallel_for")
add_test(NAME halide_correctness_autotune_bug
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug")
add_test(NAME halide_correctness_autotune_bug_2
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_2")
add_test(NAME halide_correctness_autotune_bug_3
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_3")
add_test(NAME halide_correctness_autotune_bug_4
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_4")
add_test(NAME halide_correctness_autotune_bug_5
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_5")
add_test(NAME halide_correctness_bad_likely
         COMMAND "${TS_BUILDDIR}/bin/correctness_bad_likely")
add_test(NAME halide_correctness_bit_counting
         COMMAND "${TS_BUILDDIR}/bin/correctness_bit_counting")
add_test(NAME halide_correctness_bitwise_ops
         COMMAND "${TS_BUILDDIR}/bin/correctness_bitwise_ops")
add_test(NAME halide_correctness_bool_compute_root_vectorize
         COMMAND "${TS_BUILDDIR}/bin/correctness_bool_compute_root_vectorize")
add_test(NAME halide_correctness_bound
         COMMAND "${TS_BUILDDIR}/bin/correctness_bound")
add_test(NAME halide_correctness_boundary_conditions
         COMMAND "${TS_BUILDDIR}/bin/correctness_boundary_conditions")
add_test(NAME halide_correctness_bounds
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds")
add_test(NAME halide_correctness_bounds_inference
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference")
add_test(NAME halide_correctness_bounds_inference_chunk
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference_chunk")
add_test(NAME halide_correctness_bounds_inference_complex
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference_complex")
add_test(NAME halide_correctness_bounds_of_abs
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_abs")
add_test(NAME halide_correctness_bounds_of_cast
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_cast")
add_test(NAME halide_correctness_bounds_of_func
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_func")
add_test(NAME halide_correctness_bounds_of_monotonic_math
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_monotonic_math")
add_test(NAME halide_correctness_bounds_query
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_query")
add_test(NAME halide_correctness_buffer_t
         COMMAND "${TS_BUILDDIR}/bin/correctness_buffer_t")
add_test(NAME halide_correctness_cascaded_filters
         COMMAND "${TS_BUILDDIR}/bin/correctness_cascaded_filters")
add_test(NAME halide_correctness_cast
         COMMAND "${TS_BUILDDIR}/bin/correctness_cast")
add_test(NAME halide_correctness_cast_handle
         COMMAND "${TS_BUILDDIR}/bin/correctness_cast_handle")
add_test(NAME halide_correctness_c_function
         COMMAND "${TS_BUILDDIR}/bin/correctness_c_function")
add_test(NAME halide_correctness_chunk
         COMMAND "${TS_BUILDDIR}/bin/correctness_chunk")
add_test(NAME halide_correctness_chunk_sharing
         COMMAND "${TS_BUILDDIR}/bin/correctness_chunk_sharing")
add_test(NAME halide_correctness_circular_reference_leak
         COMMAND "${TS_BUILDDIR}/bin/correctness_circular_reference_leak")
add_test(NAME halide_correctness_code_explosion
         COMMAND "${TS_BUILDDIR}/bin/correctness_code_explosion")
add_test(NAME halide_correctness_compare_vars
         COMMAND "${TS_BUILDDIR}/bin/correctness_compare_vars")
add_test(NAME halide_correctness_compile_to
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to")
add_test(NAME halide_correctness_compile_to_bitcode
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to_bitcode")
add_test(NAME halide_correctness_compile_to_lowered_stmt
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to_lowered_stmt")
add_test(NAME halide_correctness_compute_at_split_rvar
         COMMAND "${TS_BUILDDIR}/bin/correctness_compute_at_split_rvar")
add_test(NAME halide_correctness_computed_index
         COMMAND "${TS_BUILDDIR}/bin/correctness_computed_index")
add_test(NAME halide_correctness_compute_outermost
         COMMAND "${TS_BUILDDIR}/bin/correctness_compute_outermost")
add_test(NAME halide_correctness_constant_expr
         COMMAND "${TS_BUILDDIR}/bin/correctness_constant_expr")
add_test(NAME halide_correctness_constant_type
         COMMAND "${TS_BUILDDIR}/bin/correctness_constant_type")
add_test(NAME halide_correctness_constraints
         COMMAND "${TS_BUILDDIR}/bin/correctness_constraints")
add_test(NAME halide_correctness_convolution
         COMMAND "${TS_BUILDDIR}/bin/correctness_convolution")
add_test(NAME halide_correctness_convolution_multiple_kernels
         COMMAND "${TS_BUILDDIR}/bin/correctness_convolution_multiple_kernels")
add_test(NAME halide_correctness_cross_compilation
         COMMAND "${TS_BUILDDIR}/bin/correctness_cross_compilation")
add_test(NAME halide_correctness_custom_allocator
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_allocator")
add_test(NAME halide_correctness_custom_error_reporter
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_error_reporter")
add_test(NAME halide_correctness_custom_lowering_pass
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_lowering_pass")
add_test(NAME halide_correctness_debug_to_file
         COMMAND "${TS_BUILDDIR}/bin/correctness_debug_to_file")
add_test(NAME halide_correctness_deinterleave4
         COMMAND "${TS_BUILDDIR}/bin/correctness_deinterleave4")
add_test(NAME halide_correctness_div_mod
         COMMAND "${TS_BUILDDIR}/bin/correctness_div_mod")
add_test(NAME halide_correctness_dynamic_reduction_bounds
         COMMAND "${TS_BUILDDIR}/bin/correctness_dynamic_reduction_bounds")
add_test(NAME halide_correctness_erf
         COMMAND "${TS_BUILDDIR}/bin/correctness_erf")
add_test(NAME halide_correctness_exception
         COMMAND "${TS_BUILDDIR}/bin/correctness_exception")
add_test(NAME halide_correctness_explicit_inline_reductions
         COMMAND "${TS_BUILDDIR}/bin/correctness_explicit_inline_reductions")
add_test(NAME halide_correctness_extern_bounds_inference
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_bounds_inference")
add_test(NAME halide_correctness_extern_consumer
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_consumer")
add_test(NAME halide_correctness_extern_error
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_error")
add_test(NAME halide_correctness_extern_output_expansion
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_output_expansion")
add_test(NAME halide_correctness_extern_producer
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_producer")
add_test(NAME halide_correctness_extern_sort
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_sort")
add_test(NAME halide_correctness_extern_stage
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_stage")
add_test(NAME halide_correctness_fibonacci
         COMMAND "${TS_BUILDDIR}/bin/correctness_fibonacci")
add_test(NAME halide_correctness_float16_t_comparison
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_comparison")
add_test(NAME halide_correctness_float16_t_constants
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_constants")
add_test(NAME halide_correctness_float16_t_image_type
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_image_type")
add_test(NAME halide_correctness_float16_t_implicit_upcast
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_implicit_upcast")
add_test(NAME halide_correctness_float16_t_realize_constant
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_realize_constant")
add_test(NAME halide_correctness_func_lifetime
         COMMAND "${TS_BUILDDIR}/bin/correctness_func_lifetime")
add_test(NAME halide_correctness_func_lifetime_2
         COMMAND "${TS_BUILDDIR}/bin/correctness_func_lifetime_2")
add_test(NAME halide_correctness_fuse
         COMMAND "${TS_BUILDDIR}/bin/correctness_fuse")
add_test(NAME halide_correctness_fused_where_inner_extent_is_zero
         COMMAND "${TS_BUILDDIR}/bin/correctness_fused_where_inner_extent_is_zero")
add_test(NAME halide_correctness_fuzz_simplify

=== debian/changelog ===
pocl (0.13-9) unstable; urgency=medium

  * Work around using clang-3.8 with libstdc++-7-dev.  (Closes: #853620)
  * Update symbols files.
  * Switch to debhelper compat level 10.
  * Bump Standards-Version to 4.0.1.
  * Raise Priority to optional.
  * Support nodoc build.
  * Do not mark the -dev packages as Multi-Arch: foreign.
  * Move kernel-<triplet>.bc from libpocl1-common into libpocl1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 07 Aug 2017 04:57:35 +0200

pocl (0.13-8) unstable; urgency=medium

  * Enable more hardening.
  * Reduce superfluous dependencies by linking with --as-needed.
  * Update symbols files.
  * Update lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Oct 2016 13:38:39 +0200

pocl (0.13-7) unstable; urgency=medium

  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 Sep 2016 19:51:19 +0200

pocl (0.13-6) unstable; urgency=medium

  * Update symbols files.  (Closes: #835690, #836219)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 06 Sep 2016 14:55:01 +0200

pocl (0.13-5) unstable; urgency=medium

  * Build-depend on the llvm-3.8 release version.
  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Jul 2016 04:24:40 +0200

pocl (0.13-4) unstable; urgency=medium

  * Use CLOCK_UPTIME_FAST on kFreeBSD.
  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Jul 2016 16:17:52 +0200

pocl (0.13-3) experimental; urgency=medium

  * Switch to llvm 3.8.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jun 2016 14:37:21 +0200

pocl (0.13-2) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jun 2016 11:40:19 +0200

pocl (0.13-1) experimental; urgency=medium

  * New upstream release.  (Closes: #820480)
  * Refresh llvm-system-libs.patch, new upstream only supports llvm 3.7/3.8.
  * Remove fix-image-args.patch, fixed upstream.
  * glibc-2.23.patch: New, add support for glibc 2.23.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 15 Jun 2016 18:55:21 +0200

pocl (0.12-6) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 14 Jun 2016 20:11:10 +0200

pocl (0.12-5) experimental; urgency=medium

  * Switch to llvm 3.7.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Jun 2016 10:26:04 +0200

pocl (0.12-4) unstable; urgency=medium

  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Jun 2016 02:36:14 +0200

pocl (0.12-3) unstable; urgency=medium

  * Fix OpenCL headers for GNU/Hurd.
  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 May 2016 17:17:37 +0200

pocl (0.12-2) experimental; urgency=medium

  * Add B-D: sphinx-common for binary-arch builds with 'dh --with sphinxdoc'.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 May 2016 20:32:16 +0200

pocl (0.12-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 09 May 2016 14:44:03 +0200

pocl (0.11-5) unstable; urgency=medium

  * Work around clang failing to find sys/cdefs.h on !linux.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 27 May 2016 12:29:56 +0200

pocl (0.11-4) unstable; urgency=medium

  * Add B-D: sphinx-common for binary-arch builds with 'dh --with sphinxdoc'.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 May 2016 12:45:38 +0200

pocl (0.11-3) unstable; urgency=medium

  * Update symbols files.
  * Provide documentation package (pocl-doc), thanks to Ghislain Vaillant.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 May 2016 02:57:38 +0200

pocl (0.11-2) unstable; urgency=medium

  * Make the B-D on clang versioned to match llvm.
  * Drop superfluous B-D.
  * Fix testsuite failure on i386.  (Closes: #822563)
  * Switch back target cpu to pentium3 on any-i386.
  * Fix arm64 detection.  (Closes: #787686)
  * Move libpocl1-common to section utils.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 27 Apr 2016 10:17:50 +0200

pocl (0.11-1) experimental; urgency=medium

  [ Vincent Danjean ]
  * New upstream version  (Closes: #795321)
  * Switch to llvm-3.6  (Closes: #803652)
  * Fix "FTBFS on arm64" by targeting llvm arch to cortex-a53 on arm64
    (Closes: #787686)
  * Fix "vcs-browser field does not work" by fixing URL in debian/control
    (Closes: #775844)

  [ Andreas Beckmann ]
  * Use a temporary, writable $HOME while running the testsuite.
  * Show the full tests/testsuite.log on testsuite failures.
  * Drop the -dbg package in favor of autogenerated -dbgsym packages.
  * Update symbols files for amd64 and i386.
  * llvm-config --system-libs is only needed with static llvm.
  * Fix detection of image and sampler arguments, thanks to James Price.
    (Closes: #799322)
  * Put package under "Debian OpenCL Maintainers" team maintenance.
  * Add Vincent Danjean and myself to Uploaders.
  * Bump Standards-Version to 3.9.8 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 25 Apr 2016 09:49:29 +0200

pocl (0.10-12) experimental; urgency=medium

  * Update again symbol file for armel
  * apply partial fix for armhf (only one test fail, due to neon instruction)

 -- Vincent Danjean <vdanjean@debian.org>  Sun, 02 Nov 2014 01:36:13 +0100

pocl (0.10-11) experimental; urgency=medium

  * Correctly fix FreeBSD include
  * Update symbols file

 -- Vincent Danjean <vdanjean@debian.org>  Mon, 27 Oct 2014 12:31:47 +0100

=== debian/control ===
Source: pocl
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
 pkg-config,
 libhwloc-dev,
 libltdl-dev,
 ocl-icd-dev (>= 2.2.3),
 ocl-icd-libopencl1 (>= 2.2.3),
 ocl-icd-opencl-dev,
 clang-3.8,
 llvm-3.8-dev (>= 1:3.8),
 libclang-3.8-dev,
 pkg-kde-tools,
 sphinx-common,
Build-Depends-Indep:
 python-sphinx,
Standards-Version: 4.0.1
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pocl.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/pocl.git
Homepage: http://portablecl.org

Package: pocl-opencl-icd
Architecture: any
Depends:
 libpocl1 (= ${binary:Version}),
 ${misc:Depends}
Provides:
 opencl-icd,
 opencl-icd-1.1-1,
 opencl-icd-1.2-1,
Description: pocl ICD
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package allows one to use pocl as an installable client driver (ICD) for
 OpenCL.

Package: libpocl1-common
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends}
Description: common files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the architecture independent files of the pocl library.

Package: libpocl1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libpocl1-common (= ${source:Version}),
 clang-${LLVM:Version},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 pocl-opencl-icd,
Breaks:
 libpocl1-common (<< 0.13-9),
Replaces:
 libpocl1-common (<< 0.13-9),
Description: Portable Computing Language library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the core of pocl.

Package: libpoclu1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: utility library for writing OpenCL programs
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides an small utility library to help writing OpenCL
 programs.

Package: libpoclu-dev
Architecture: any
Section: libdevel
Depends:
 libpoclu1 (= ${binary:Version}),
 opencl-headers,
 ${misc:Depends}
Recommends:
 ocl-icd-opencl-dev,
Description: development files for the pocl utility library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl utility library,
 that provides various facilities to write OpenCL programs.

Package: libpocl-dev
Architecture: any
Section: libdevel
Depends:
 libpocl1 (= ${binary:Version}),
 ${misc:Depends}
Description: development files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library. Unless very
 specific needs, this package is useless. This package is only required to link
 directly and explicitly with pocl.
 .
 To develop OpenCL programs (that can be run with pocl), the opencl-dev virtual
 package (provided by ocl-icd-opencl-dev for example) is required, not this one.

Package: pocl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library.  Unless very
 specific needs, this package is useless.  This package is only required to link
 directly and explicitly with pocl.
 .
 This package provides the documentation for the pocl library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# When updating this variable, do not forget to adapt the build-depends
# in debian/control
LLVM_VERSION=3.8

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_HOST_MULTIARCH
DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
LLVM_ARCH=$(shell sed < debian/supported-archs \
	-e '/^DEB_ARCH: $(DEB_HOST_ARCH)$$/,/^ *$$/p;d' \
	| sed -e 's/^LLVM_ARCH=//p;d')

ifneq ($(LLVM_ARCH),)
export LLC_HOST_CPU=$(LLVM_ARCH)
endif

ifeq ($(DEB_HOST_ARCH),armhf)
# NEON, optional for Debian, must not be used
export CLANG_FLAGS= -mfpu=vfp3-d16
#export KERNEL_LIB_OPT_FLAGS= -mattr=-neon
export KERNEL_LIB_OPT_FLAGS= -mattr=-neon,+d16,+vfp3,-vfp4,+v7,+aclass,+thumb2
endif

# doc for symbols:
# http://www.eyrie.org/~eagle/journal/2012-01/008.html
# main packaging script based on dh7 syntax
%:
	dh $@ --with pkgkde_symbolshelper --with sphinxdoc

.PHONY: override_dh_auto_configure override_dh_shlibdeps override_dh_install
.PHONY: override_dh_auto_test override_dh_makeshlibs

override_dh_autoreconf:
ifeq ($(LLVM_ARCH),)
	$(warning Experimental architecture. Build failure expected)
endif
	@echo Using LLC_HOST_CPU=$${LLC_HOST_CPU}
	-/usr/lib/llvm-$(LLVM_VERSION)/bin/llc -mattr=help
	dh_autoreconf --as-needed autoreconf -- -vif -Wall -Wno-obsolete

override_dh_auto_configure:
	dh_auto_configure -- --enable-icd --disable-static \
		LLVM_CONFIG=/usr/bin/llvm-config-$(LLVM_VERSION)

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	sphinx-build -N -b html doc/sphinx/source build-doc/html
else
	mkdir -p build-doc/html
endif

override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

override_dh_install:
	sed -i debian/tmp/etc/OpenCL/vendors/pocl.icd \
		-e 's,.*/\([^/.]*\.so\.[^/.]*\)\.[^/]*,\1,'
	dh_install -Xusr/include/CL/ -X.la -Xusr/include/utlist.h

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_test:
	# Failure in testsuite is delayed until symbols handling
	# and all files are logged.
	$(RM) debian/stamp-failed-testsuite
	$(RM) -r debian/testsuite-tmp-home
	mkdir debian/testsuite-tmp-home
	if ! HOME=$(CURDIR)/debian/testsuite-tmp-home dh_auto_test ; then \
		for f in $$(find tests/testsuite.dir -type f | sort) tests/testsuite.log; do \
			echo "******************************************" ;\
			echo "* File: $$f" ;\
			echo "******************************************" ;\
			cat $$f ;\
			echo "******************************************" ;\
		done ;\
		touch debian/stamp-failed-testsuite; \
	fi
	$(RM) -r debian/testsuite-tmp-home

run_dh_makeshlibs:
	dh_makeshlibs

delayed_check_dh_auto_test_result: run_dh_makeshlibs
	if test -f debian/stamp-failed-testsuite ; then \
		echo "***** The testsuite has failed! *****" ; \
		grep '^ .*FAILED' < tests/testsuite.log ; \
		sed -r '/Summary of the failures/,/Skipped tests/{/Skipped tests/d;p};d' tests/testsuite.log ; \
		exit 1 ; \
	fi
	@test -f tests/testsuite.log && echo 'The testsuite has passed all tests.' || echo '*** The testsuite was *NOT* run! ***'

override_dh_makeshlibs: run_dh_makeshlibs delayed_check_dh_auto_test_result

override_dh_gencontrol:
	dh_gencontrol -- -V'LLVM:Version=$(LLVM_VERSION)'


version			 = $(shell dpkg-parsechangelog --show-field Version)
upstream_version	 = $(shell dpkg-parsechangelog --show-field Version | sed -e 's/-[^-]*$$//')
distribution		 = $(shell dpkg-parsechangelog --show-field Distribution)

fix-symbols:
	pkgkde-getbuildlogs
	echo "pkgkde-symbolshelper batchpatch -v $(upstream_version) pocl_$(distribution)_logs/pocl_$(version)_*build"
